/* Poniszy kod pochodzi z ksiki
* "C++. Programowanie zorientowane obiektowo.
* Vademecum profesjonalisty"
* autorstwa Nicolai M. Josuttisa, wydanej
* w Polsce przez wydawnictwo HELION S.A. w 2003 roku
* (wydanie oryginalne: Wiley, 2002)
*
* (C) Copyright Nicolai M. Josuttis 2002.
* Kopiowanie, wykorzystywanie, modyfikacja
* i rozpowszechnianie niniejszego oprogramowania
* jest dozwolone pod warunkiem zamieszczenia
* niniejszej informacji o prawach autorskich.
* Oprogramowanie to jest udostpniane
* bez jakichkolwiek gwarancji.
*/

#include <iostream>
#include <cstddef>

void* MyClass::operator new (std::size_t size)
{
    // wywietla komunikat
    std::cout << "operator MyClass::new" << std::endl;

    // wywouje globalny operator new 
    // w celu przydziau obszaru pamici o rozmiarze size
    return  ::new char[size];
}

void* MyClass::operator new[] (std::size_t size)
{
    // wywietla komunikat
    std::cout << "operator MyClass::new[]" << std::endl;

    // wywouje globalny operator new 
    // w celu przydziau obszaru pamici o rozmiarze size
    return  ::new char[size];
}

