/* Poniszy kod pochodzi z ksiki
* "C++. Programowanie zorientowane obiektowo.
* Vademecum profesjonalisty"
* autorstwa Nicolai M. Josuttisa, wydanej
* w Polsce przez wydawnictwo HELION S.A. w 2003 roku
* (wydanie oryginalne: Wiley, 2002)
*
* (C) Copyright Nicolai M. Josuttis 2002.
* Kopiowanie, wykorzystywanie, modyfikacja
* i rozpowszechnianie niniejszego oprogramowania
* jest dozwolone pod warunkiem zamieszczenia
* niniejszej informacji o prawach autorskich.
* Oprogramowanie to jest udostpniane
* bez jakichkolwiek gwarancji.
*/

#include <iostream>
#include <vector>
#include <list>
#include <deque>
#include <algorithm>

int main()
{
    std::list<int>   coll1;
    std::vector<int> coll2;
    std::deque<int>  coll3;

    // wstawia elementy o wartociach od 1 do 6 do pierwszej kolekcji
    for (int i=1; i<=6; i++) {
        coll1.push_back(i);
    }

    // kopiuje elementy umieszczajc je na kocu drugiej kolekcji
    std::copy(coll1.begin(), coll1.end(),    // zakres rdowy
              std::back_inserter(coll2));    // zakres docelowy

    // kopiuje elementy umieszczajc je na pocztku trzeciej kolekcji
    std::copy(coll1.begin(), coll1.end(),    // zakres rdowy
              std::front_inserter(coll3));   // zakres docelowy
}

